मैंने एक सर्वर को क्लोन किया और इसलिए उनके पास एक ही आरएसए कुंजी फिंगरप्रिंट है।
इसमें परिभाषित किया गया है /etc/ssh/ssh_host_rsa_key.pub
।
उसे बदलने का सही तरीका क्या है?
धन्यवाद।
मैंने एक सर्वर को क्लोन किया और इसलिए उनके पास एक ही आरएसए कुंजी फिंगरप्रिंट है।
इसमें परिभाषित किया गया है /etc/ssh/ssh_host_rsa_key.pub
।
उसे बदलने का सही तरीका क्या है?
धन्यवाद।
जवाबों:
या, चाबियाँ निकालें और
ssh-keygen -A
स्पष्टीकरण:
-A
: प्रत्येक कुंजी प्रकार (rsa1, rsa, dsa, ecdsa और ed25519) के लिए, जिसके लिए होस्ट कुंजी मौजूद नहीं है, डिफ़ॉल्ट कुंजी फ़ाइल पथ के साथ होस्ट कुंजी उत्पन्न करें, एक खाली पासफ़्रेज़, कुंजी प्रकार के लिए डिफ़ॉल्ट बिट्स, और डिफ़ॉल्ट टिप्पणी। इसका उपयोग नई होस्ट कुंजी उत्पन्न करने के लिए / etc / rc द्वारा किया जाता है।
ssh-keygen -A
निम्न कार्य करता है: "प्रत्येक कुंजी प्रकार (rsa1, rsa, dsa, ecdsa और ed25519) के लिए, जिसके लिए होस्ट कुंजी मौजूद नहीं है, मेजबान बनाएँ डिफ़ॉल्ट कुंजी फ़ाइल पथ के साथ कुंजी, एक खाली पासफ़्रेज़, कुंजी प्रकार के लिए डिफ़ॉल्ट बिट्स, और डिफ़ॉल्ट टिप्पणी। यह नई होस्ट कुंजी उत्पन्न करने के लिए / etc / rc द्वारा उपयोग किया जाता है। "
ओपनएसएसएच होस्ट कीज को पुनर्जीवित करने के लिए इन चरणों का पालन करें
rm /etc/ssh/ssh_host_*
dpkg-reconfigure openssh-server
~/.ssh/known_hosts
फाइलों ) को अपडेट करेंऐसा करने की एक सामान्य विधि के लिए:
ssh-keygen -q -N "" -t dsa -f /etc/ssh/ssh_host_dsa_key
ssh-keygen -q -N "" -t rsa -b 4096 -f /etc/ssh/ssh_host_rsa_key
ssh-keygen -q -N "" -t ecdsa -f /etc/ssh/ssh_host_ecdsa_key
मिक्स और मैच के अनुसार OpenSSH का आपका संस्करण समर्थन करता है।
ssh-keygen -q -N "" -t rsa -b 4096 -f /etc/ssh/ssh_host_rsa_key
उन्हें हटाएं और SSHd सेवा को पुनरारंभ करें। उन्हें पुनर्जीवित किया जाएगा।
/etc/init.d/ssh restart<newline> Could not load host key: /etc/ssh/ssh_host_rsa_key<newline> Could not load host key: /etc/ssh/ssh_host_dsa_key<newline> [....] Restarting OpenBSD Secure Shell server: sshdCould not load host key: /etc/ssh/ssh_host_rsa_key<newline> Could not load host key: /etc/ssh/ssh_host_dsa_key
स्क्रिप्ट (मामले में sshd डेमॉन को फिर से शुरू करने से स्वचालित रूप से कुंजियों का पुनर्जनन नहीं होता है)
#!/bin/bash
# Regenerate SSHD key materials, restart sshd if "-r" passed on command line
set -o nounset
WHERE=/etc/ssh
# go to directory
pushd $WHERE >/dev/null
if [[ $? != 0 ]]; then
echo "Could not cd to $WHERE -- exiting" >&2
exit 1
fi
# create backup folder
NOW=`date '+%Y%m%d.%H%M%S'` # default NOW string
BAKDIR=bak_$NOW
mkdir $BAKDIR
if [[ $? != 0 ]]; then
echo "Could not mkdir $BAKDIR -- exiting" >&2
exit 1
fi
# move existing key material to backup folder
mv ssh_host_* $BAKDIR
if [[ $? != 0 ]]; then
echo "Could not move old files to $BAKDIR -- exiting" >&2
exit 1
fi
# generate new keys
ssh-keygen -A
if [[ $? != 0 ]]; then
echo "Could not recreate keys -- exiting" >&2
exit 1
fi
# ssh-keygen may create DSA keys but:
# "Never use DSA or ECDSA"
# http://security.stackexchange.com/questions/5096/rsa-vs-dsa-for-ssh-authentication-keys
/bin/rm -f *_dsa_key *_dsa_key.pub
/bin/rm -f *_ecdsa_key *_ecdsa_key.pub
# on Fedora, one has to tune permissions a bit
chmod 640 *_key
chgrp ssh_keys *_key
# make sure SELinux attributes are as they should be
restorecon -R $WHERE
# Done
echo "New key material"
ls -l *_key *_key.pub
# Do the risky thing
if [[ $1 == '-r' ]]; then
echo "Restarting SSH daemon"
systemctl restart sshd
fi
# go back to where you where
popd >/dev/null